/*
File: roomread.c (external)
Desc: quick hack to dump contents of room <argv1>
Source: pirmann@demigod.rutgers.edu
*/

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/signal.h>
#include <pwd.h>
#include <setjmp.h>
#include "citadel.h"
char msgfile[100], structfile[100];
int rtr;
struct fullroom fullroom;
struct quickroom quickroom;
struct msgmain msgmain;

char *months[12]=
{
  "Jan","Feb","Mar","Apr","May","Jun",
  "Jul","Aug","Sep","Oct","Nov","Dec" 
};

char *days[7] = 
{ 
  "Sun","Mon","Tue","Wed","Thu","Fri","Sat"  
  };

fpgetfield (fp,string)	/* level-2 break out next null-terminated string */
     FILE *fp;
     char string[];
{
  int a,b;

  strcpy(string,"");
  a=0;
  do 
    {
      b=getc(fp);
      if (b<1) 
	{ 
	  string[a]=0;
	  return(0); 
	}
      string[a]=b;
      ++a;
    } 
  while(b!=0);
  return(0);
}
fmout2(width,fp)
     int width;
     FILE *fp;
{
  int a,b,c,real,old=0,l;
  char aaa[140];
	
  l = 1;
  strcpy(aaa,""); 
  old=255;
  c=1;            /* c is the current pos */
 FMTA2:	
  old=real; 
  a=getc(fp); 
  real=a;
  if (a<=0) 
    goto FMTEND2;
	
  if ( ((a==13)||(a==10)) && (old!=13) && (old!=10) ) 
    a=32;
  if ( ((old==13)||(old==10)) && (isspace(real)) ) 
    {
      printf("\n"); 
      c=1; 
    }
  if (a>126) 
    goto FMTA2;
  if (a>32) 
    {
      if ( ((strlen(aaa)+c)>(width-5)) && (strlen(aaa)>(width-5)) )
	{ 
	  printf("\n%s",aaa); 
	  c=strlen(aaa); 
	  aaa[0]=0; 
	}
      b=strlen(aaa); 
      aaa[b]=a; 
      aaa[b+1]=0; 
    }
  if (a==32)
    {
      if ((strlen(aaa)+c)>(width-5)) 
	{
	  printf("\n");
	  c=1;
	}
      printf("%s ",aaa); 
      ++c; 
      c=c+strlen(aaa);
      strcpy(aaa,""); 
      goto FMTA2; 
    }
  if ((a==13)||(a==10)) 
    {
      printf("%s\n",aaa);
      c=1;
      strcpy(aaa,""); 
      goto FMTA2; 
    }
  goto FMTA2;

 FMTEND2: 
  printf("\n");
  return(0);
}

strucmp (st1,st2) /* Compares two strings without case sensitivity */
     char st1[],st2[]; 
{
  char aaa[100],bbb[100];
  int a;
  
  for (a=0; a<=strlen(st1); ++a)
    aaa[a]=tolower(st1[a]);
  for (a=0; a<=strlen(st2); ++a) 
    bbb[a]=tolower(st2[a]);
  return(strcmp(aaa,bbb));
}


read_message(pos)	        /* Read a message from the master file */
     long pos;			/* Position in master file */
{
  int a;
  sprintf (msgfile,"msgmains/msgmain.%d", rtr);
  msgform(80,pos,msgfile);
  return(0);
}


readmsgs(rtr)	/* read contents of a room */
int rtr;
{
/* odir = 1 for forward reading */
/* c = 0 for reading all */
/* b = starting point to read at, 0 for beginning */

  int a, b, c, e, file, rdir, odir;
  long cc;
  struct msgmain msgmain;
  
  signal(SIGINT,SIG_IGN);
  signal(SIGQUIT,SIG_IGN);
  c = 0; b = 0;
  odir = 1;
  rdir = odir; /* start us off in the right direction */
  sprintf (structfile, "structures/MMstructure.%d", rtr);
  cc = 0;

  file=eopen(structfile,O_RDONLY);
  a=read(file,&msgmain,sizeof(struct msgmain));
  if (a<1)exit(45);
  close(file);

  for (a=b; ((a<MSGSPERRM)&&(a>=0)); a=a+1) 
    {
      while ( (fullroom.FRnum[a]==0L)
	     ||  (fullroom.FRnum[a]<msgmain.MMlowest)
	     || ((c==1)&&(fullroom.FRnum[a]<cc))
	     || ((c==2)&&(fullroom.FRnum[a]>=cc)))
	{
	  a=a+rdir;
	  if ((a==MSGSPERRM)||(a==(-1))) 
	    {
	      printf ("oops!\n");
	      return(0);
	    }
	}
      c = 0;
      e=read_message(fullroom.FRpos[a]);
      if (e==2) return(0);

    } /* end for loop */

  return(0);
} /* end read routine */


eopen(name,mode)
     char *name;
     int mode; 
{
  int ret;
  ret=open(name,mode);
  if (ret<0) 
    {
      fprintf(stderr,"Cannot open file '%s', mode=%d\n",name,mode);
      exit(1);
    }
  return(ret);
}

msgform(width,spos,mfile)
     int width;
     long spos;
     char *mfile;
{
  struct tm *tm;
  int a,b,e,mtype,aflag;
  char bbb[100];
  FILE *fp;
  long now;
  char *strchr();

  fp=fopen(mfile,"rb");
  if (fp==NULL)
    return(1);
  fseek(fp,spos,0);
  e=getc(fp);
  if (e!=255) 
    {
      printf("*** CANNOT LOCATE MESSAGE / pos=%ld\n",spos);
      return(1);
    }
  mtype=getc(fp);
  aflag=getc(fp);
  printf("\n");
  if (mtype==MES_ANON)
    printf("***** "); 
  if (mtype==MES_AN2)
    printf("<anonymous> ");
  do
    {
      b=getc(fp);
      if (b=='M')
	{
	  printf("\n");
	  if (aflag!=1)
	    fmout2(width,fp);
	  else
	    while(a=getc(fp), a>0)
	      {
		putc(a,stdout);
		if (a==13)
		  putc(10,stdout);
	      }
	}
      if ((b!='M')&&(b>0))
	fpgetfield(fp,bbb);

      if ( (mtype!=MES_ANON && mtype!=MES_AN2) )
	{
	  if (b=='A') 
	    {
	      printf("from %s ",bbb);
	    }
	  if (b=='I')
	    printf("#%d-%s ",rtr,bbb);
	  if ((b=='O')&&(strucmp(bbb,quickroom.QRname)))
	    printf("in %s> ",bbb);
	  if (b=='T') 
	    {
	      now=atol(bbb);
	      tm=(struct tm *)localtime(&now);
	      sprintf(bbb,"%s %s", days[tm->tm_wday], asctime(tm));
	      bbb[strlen(bbb)-1]=0;
	      printf("%s ",&bbb[4]);
	    }
	}
    }
  while ((b!='M')&&(b>0));
  printf("\n");
  fclose(fp);
  return(0);
}

main(argc, argv)
int argc;
char *argv[];
{
  int file;
  char aaa[100];
  int d;

  chdir (BBSDIR);

  rtr = atoi (argv[1]);
  file=open("quickroom",O_RDONLY);
  lseek(file,(long)(rtr*sizeof(struct quickroom)),0);
  d=read(file,&quickroom,sizeof(struct quickroom));
  close(file);
  sprintf(aaa,"./rooms/fullrm%d",rtr);
  file=open(aaa,O_RDONLY);
  d=read(file,&fullroom,sizeof(struct fullroom));
  close (file);
  readmsgs (rtr);
}
